VERSION 4.00
Begin VB.Form frmToolbar 
   Appearance      =   0  'Flat
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   1095
   ClientLeft      =   1125
   ClientTop       =   1500
   ClientWidth     =   7035
   ControlBox      =   0   'False
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   1
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Height          =   1500
   KeyPreview      =   -1  'True
   Left            =   1065
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1095
   ScaleWidth      =   7035
   Top             =   1155
   Width           =   7155
   Begin PicClip.PictureClip picToolbar 
      Left            =   600
      Top             =   120
      _version        =   65536
      _extentx        =   11113
      _extenty        =   1482
      _stockprops     =   0
      rows            =   2
      cols            =   15
      picture         =   "FLOAT_TB.frx":0000
   End
   Begin VB.Image imgToolbar 
      Appearance      =   0  'Flat
      Height          =   375
      Index           =   0
      Left            =   120
      Top             =   120
      Width           =   375
   End
End
Attribute VB_Name = "frmToolbar"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

'Toolbar metrics
Const TITLE_HEIGHT = 7  'Height of title bar in pixels
Const CTRLBOXWIDTH = 10 'Width of control box in pixels



'Variables to track user dragging the toolbar
Dim isDragging As Integer
Dim dragXY As POINTAPI
Dim dragOffset As POINTAPI

'Used to track active/inactive title bar color
Dim titleColor As Long

Private Sub DrawPhantomRect()
    Dim i As Long, hDC As Integer, Rc As RECT

    'Draw a phantom rectangle to indicate user is dragging toolbar
    'NOTE: Since the rectangle uses XOR, drawing the same rectangle
    'twice erases the first.

    'Get device context to desktop
#If Win32 Then
  'TODO: Function/Sub GETDC parameters should be checked against the calling convention on the next line.
  'Declare Function GetDC Lib "user32" Alias "GetDC" (ByVal hwnd As Long) As Long
#Else
      hDC = GetDC(0&)
#End If
    'Calculate rectangle coordinates in screen pixels
    Rc.left = ((left / Screen.TwipsPerPixelX) + (dragXY.x - dragOffset.x))
    Rc.Top = ((Top / Screen.TwipsPerPixelY) + (dragXY.y - dragOffset.y))
    Rc.right = Rc.left + (Width / Screen.TwipsPerPixelX)
    Rc.bottom = Rc.Top + (Height / Screen.TwipsPerPixelY)
    'Draw phantom rectangle
#If Win32 Then
  'TODO: Function/Sub DRAWFOCUSRECT parameters should be checked against the calling convention on the next line.
'TODO: -> Unknown WinAPI/Third-Party DLL Call -> DRAWFOCUSRECT  Check Calling convention for compatibility with BSTR/UNICODE/ANSI Strings. See VB4DLL.TXT in VB directory.
    Call DrawFocusRect(hDC, Rc)
#Else
      Call DrawFocusRect(hDC, Rc)
#End If
    'Release device context
#If Win32 Then
  'TODO: Function/Sub RELEASEDC parameters should be checked against the calling convention on the next line.
  'Declare Function ReleaseDC Lib "user32" Alias "ReleaseDC" (ByVal hwnd As Long, ByVal hdc As Long) As Long
#Else
      i = ReleaseDC(0&, hDC)
#End If
End Sub

Private Sub Form_Activate()
    'Change title color to active
#If Win32 Then
  'TODO: Function/Sub GETSYSCOLOR parameters should be checked against the calling convention on the next line.
  'Declare Function GetSysColor Lib "user32" Alias "GetSysColor" (ByVal nIndex As Long) As Long
#Else
      titleColor = GetSysColor(COLOR_ACTIVECAPTION)
#End If
    Call Form_Paint
End Sub

Private Sub Form_Deactivate()
    'Change title color to inactive
#If Win32 Then
  'TODO: Function/Sub GETSYSCOLOR parameters should be checked against the calling convention on the next line.
  'Declare Function GetSysColor Lib "user32" Alias "GetSysColor" (ByVal nIndex As Long) As Long
#Else
      titleColor = GetSysColor(COLOR_INACTIVECAPTION)
#End If
    Call Form_Paint
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    'If we are dragging toolbar, prevent keys from being processed
    If isDragging Then KeyCode = 0
End Sub

Private Sub Form_Load()
    Dim i As Integer, imgWidth As Integer, imgHeight As Integer

    'Make toolbar a child window of the main window so that it always
    'remains on top of the main window, but not other windows
#If Win32 Then
  'TODO: Function/Sub SETWINDOWWORD parameters should be checked against the calling convention on the next line.
  'Declare Function SetWindowWord Lib "user32" Alias "SetWindowWord" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal wNewWord As Long) As Long
#Else
      Call SetWindowWord(hWnd, SWW_HPARENT, frmMain.hWnd)
#End If
    'Simplify graphics a little by using pixel scale mode
    frmToolbar.ScaleMode = 3
    'Load, size, and position each toolbar button
    imgToolbar(i) = picToolbar.GraphicCell(0)
    imgToolbar(0).Move 2, TITLE_HEIGHT + 3
    imgWidth = imgToolbar(i).Width: imgHeight = imgToolbar(i).Height
    For i = 1 To (picToolbar.Cols - 1)
        Load imgToolbar(i)
        imgToolbar(i) = picToolbar.GraphicCell(i)
        If (i And 1) = 0 Then   'Left side
            imgToolbar(i).Move 2, imgToolbar(i - 1).Top + (imgHeight - 1)
        Else                    'Right side
            imgToolbar(i).Move 1 + imgWidth, imgToolbar(i - 1).Top
        End If
        imgToolbar(i).Visible = True
    Next i
    'Size toolbar window to fit buttons
    Width = ((imgWidth * 2) + 5) * Screen.TwipsPerPixelX
    Height = ((((picToolbar.Cols + 1) \ 2) * (imgHeight - 1)) + 8 + TITLE_HEIGHT) * Screen.TwipsPerPixelY
    'Position toolbar at remembered location
    left = toolbarX: Top = toolbarY
    'Indicate which tool is selected
    Call SetCurrentTool(currTool)
    'Indicate toolbar is visible
    toolbarVisible = True
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim i As Long

    'Since our title bar and control box are simulated, we need to check if the mouse is
    'pressed within one of them. If the control box is clicked, we close the toolbar. If
    'the title bar is clicked, we allow the user to drag the toolbar to another location.
    If Button = 1 And y <= TITLE_HEIGHT And Not isDragging Then
        If x < CTRLBOXWIDTH Then    'Control box
            Unload Me
        Else                        'Title bar
            'Note that VB will automatically send us all mouse events
            'while the mouse button is held down
            isDragging = True
            'Save starting postion and offset from top, left of form
            dragXY.x = CInt(x)
            dragXY.y = CInt(y)
            dragOffset.x = dragXY.x
            dragOffset.y = dragXY.y
            'Draw initial phantom rectangle
            Call DrawPhantomRect
        End If
    End If
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    'Update phantom rectangle if user is dragging toolbar
    If isDragging Then
        'Erase current rectangle
        Call DrawPhantomRect
        'Get new position
        dragXY.x = CInt(x)
        dragXY.y = CInt(y)
        'Draw new rectangle
        Call DrawPhantomRect
    End If
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    'If user was dragging toolbar, release mouse capture and move toolbar to new position
    If Button = 1 And isDragging Then
        'Erase current rectangle
        Call DrawPhantomRect
        'Move toolbar to new position
        Move left + ((x - dragOffset.x) * Screen.TwipsPerPixelX), Top + ((y - dragOffset.y) * Screen.TwipsPerPixelY)
        'Turn off global flag
        isDragging = False
    End If
End Sub

Private Sub Form_Paint()
    'Paint control box
    FillStyle = 0    'Solid
    Line (0, 0)-(CTRLBOXWIDTH, TITLE_HEIGHT), RGB(192, 192, 192), BF
    FillColor = RGB(255, 255, 255)
    Line (3, 3)-(8, 5), RGB(128, 128, 128), B
    Line (2, 2)-(7, 4), , B
    'Paint title bar
    Line (CTRLBOXWIDTH, 0)-(ScaleWidth, TITLE_HEIGHT), titleColor, BF
    'Draw lines to separate control box, title bar, form
    Line (0, TITLE_HEIGHT)-(ScaleWidth, TITLE_HEIGHT)
    Line (CTRLBOXWIDTH, 0)-(CTRLBOXWIDTH, TITLE_HEIGHT)
    'Draw container rectangle for buttons (only shows if
    'there are an odd number of buttons on the toolbar
    FillStyle = 1    'Transparent
    Line (2, TITLE_HEIGHT + 3)-Step((imgToolbar(0).Width * 2) - 2, (imgToolbar(0).Height - 1) * ((picToolbar.Cols + 1) \ 2)), RGB(0, 0, 0), B
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Save toolbar position
    toolbarX = left: toolbarY = Top
    'Indicate toolbar is no longer visible
    toolbarVisible = False
End Sub

Private Sub imgToolbar_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    'Set selected tool if left button was pressed
    If Button And 1 Then Call SetCurrentTool(Index)
End Sub

Private Sub SetCurrentTool(toolNumber As Integer)
    'Make previous tool is set to up position
    imgToolbar(currTool) = picToolbar.GraphicCell(currTool)
    'Set the selected image to the down postion
    currTool = toolNumber
    imgToolbar(currTool) = picToolbar.GraphicCell(currTool + picToolbar.Cols)
End Sub

