Attribute VB_Name = "LibHelp"
Option Explicit

' ***************************************************
' Help File and About API Calls
' ***************************************************
'
' ***************************************************
' * Use this if you are building your project under VB3
' Declare Function WinHelp Lib "User" (ByVal hwnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, ByVal dwData As Any) As Integer
' * end of VB3 version
' ***************************************************

' ***************************************************
' * use this if you are building your project under VB4
#If Win16 Then
    Declare Function WinHelp Lib "User" (ByVal hwnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, ByVal dwData As Any) As Integer
#Else
    Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Any) As Long
#End If
' * end of VB4 version
' ****************************************************

' ****************************************************
' * help routine constants (VB3 and VB4)
Global Const HELP_QUIT = 2
Global Const HELP_INDEX = 3
Global Const HELP_HELPONHELP = 4
Global Const HELP_PARTIALKEY = &H105



Sub HelpFunc(frmForm As Form, nHelpCmd As Integer, cHelpKey As String)
    '
    ' make calls to the Windows Help System
    '
    Dim i As Integer
    Dim nFlag As Integer
    Dim aData As Variant
    '
    ' trap for missing help file
    If Len(LTrim(RTrim(App.HelpFile))) = 0 Then
       MsgBox "No Help File Available"
       GoTo HelpFunc_Exit
    End If
    '
    ' check for valid help command
    Select Case nHelpCmd
       Case Is = HELP_QUIT ' close help child
          nFlag = True
       Case Is = HELP_INDEX ' show contents page
          nFlag = True
       Case Is = HELP_HELPONHELP ' show help on help
          nFlag = True
       Case Is = HELP_PARTIALKEY ' show search dialog
          nFlag = True
       Case Else
          nFlag = False 'invalid command!
    End Select
    '
    If nFlag = True Then
       If nHelpCmd = HELP_PARTIALKEY Then
          i = WinHelp(frmForm.hwnd, App.HelpFile, nHelpCmd, cHelpKey)
       Else
          i = WinHelp(frmForm.hwnd, App.HelpFile, nHelpCmd, 0&)
       End If
    Else
       MsgBox "Invalid Help Command Value"
    End If
    '
HelpFunc_Exit:
    '
End Sub

